﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.28
@EndOfDesignText@
Sub Class_Globals
	Dim J As JavaObject
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	J=Me
End Sub

Public Sub procesa(lang As String, inputFile As String, outputFile As String, repeat As Int)
	J.RunMethod("processStemmer", Array(lang, inputFile, outputFile, repeat))
End Sub


'====================================================================================
' Este es el contenido de TestApp.java, adaptado para la ocasión.
'===================================================================================='
#if JAVA

import java.lang.reflect.Method;
import java.io.Reader;
import java.io.Writer;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.OutputStream;
import java.io.FileOutputStream;

import org.tartarus.snowball.*;

public void processStemmer(String lang, String inputFile, String outputFile, int repeat) {

	Class stemClass = this.getClass();	//asi evitamos error de posiblemente no inicializado;
    SnowballStemmer stemmer;
	
	try{
		stemClass = Class.forName("org.tartarus.snowball.ext." + lang + "Stemmer");
        stemmer = (SnowballStemmer) stemClass.newInstance();
	


	Reader reader;
	reader = new InputStreamReader(new FileInputStream(inputFile));
	reader = new BufferedReader(reader);

	StringBuffer input = new StringBuffer();

        OutputStream outstream;
		     outstream = new FileOutputStream(outputFile);
//	    outstream = System.out;

	Writer output = new OutputStreamWriter(outstream);
	output = new BufferedWriter(output);

	if (repeat<=0) repeat=1;	// parece que 1 es el default. Protegemos.

	Object [] emptyArgs = new Object[0];
	int character;
	while ((character = reader.read()) != -1) {
	    char ch = (char) character;
	    if (Character.isWhitespace((char) ch)) {
			if (input.length() > 0) {
		    	stemmer.setCurrent(input.toString());
		    	for (int i = repeat; i != 0; i--) {
					stemmer.stem();
		    	}
		    	output.write(stemmer.getCurrent());
		    	output.write('\n');
		    	input.delete(0, input.length());
			}
	    } else {
			input.append(Character.toLowerCase(ch));
	    }
	}
	output.flush();
    
	}
	catch(Exception e){
		BA.Log("Class not found");
	}	
/*	catch(ClassNotFoundException e){
		BA.Log("Class not found");
	}
	catch(InstantiationException ee) {
		BA.Log("Insantiation exception");
	}
	catch(IllegalAccessException ee) {
		BA.Log("Insantiation exception");
	}
	catch(FileNotFoundException ee) {
		BA.Log("Insantiation exception");
	}*/
}



#End If